package com.sun.jndi.toolkit.ctx;

import javax.naming.InvalidNameException;
import javax.naming.NameNotFoundException;
import javax.naming.LinkRef;
import javax.naming.CompositeName;
import javax.naming.Reference;
import javax.naming.RefAddr;
import javax.naming.NameParser;
import javax.naming.Name;
import javax.naming.Context;
import javax.naming.Binding;
import javax.naming.NameClassPair;
import javax.naming.NamingEnumeration;
import javax.naming.NamingException;

public abstract class AtomicContext extends ComponentContext
{
    private static int debug;
    
    protected AtomicContext() {
        this._contextType = 3;
    }
    
    protected abstract Object a_lookup(String p0, Continuation p1) throws NamingException;
    
    protected abstract Object a_lookupLink(String p0, Continuation p1) throws NamingException;
    
    protected abstract NamingEnumeration<NameClassPair> a_list(Continuation p0) throws NamingException;
    
    protected abstract NamingEnumeration<Binding> a_listBindings(Continuation p0) throws NamingException;
    
    protected abstract void a_bind(String p0, Object p1, Continuation p2) throws NamingException;
    
    protected abstract void a_rebind(String p0, Object p1, Continuation p2) throws NamingException;
    
    protected abstract void a_unbind(String p0, Continuation p1) throws NamingException;
    
    protected abstract void a_destroySubcontext(String p0, Continuation p1) throws NamingException;
    
    protected abstract Context a_createSubcontext(String p0, Continuation p1) throws NamingException;
    
    protected abstract void a_rename(String p0, Name p1, Continuation p2) throws NamingException;
    
    protected abstract NameParser a_getNameParser(Continuation p0) throws NamingException;
    
    protected abstract StringHeadTail c_parseComponent(String p0, Continuation p1) throws NamingException;
    
    protected Object a_resolveIntermediate_nns(String comp, Continuation continuation) throws NamingException {
        try {
            final Object a_lookup = this.a_lookup(comp, continuation);
            if (a_lookup != null && this.getClass().isInstance(a_lookup)) {
                continuation.setContinueNNS(a_lookup, comp, this);
                return null;
            }
            if (a_lookup != null && !(a_lookup instanceof Context)) {
                Reference reference = new Reference("java.lang.Object", new RefAddr("nns") {
                    private static final long serialVersionUID = -3399518522645918499L;
                    
                    @Override
                    public Object getContent() {
                        return a_lookup;
                    }
                });
                CompositeName compositeName = new CompositeName();
                compositeName.add(comp);
                compositeName.add("");
                continuation.setContinue(reference, compositeName, this);
                return null;
            }
            return a_lookup;
        }
        catch (NamingException ex) {
            ex.appendRemainingComponent("");
            throw ex;
        }
    }
    
    protected Object a_lookup_nns(String s, Continuation continuation) throws NamingException {
        this.a_processJunction_nns(s, continuation);
        return null;
    }
    
    protected Object a_lookupLink_nns(String s, Continuation continuation) throws NamingException {
        this.a_processJunction_nns(s, continuation);
        return null;
    }
    
    protected NamingEnumeration<NameClassPair> a_list_nns(Continuation continuation) throws NamingException {
        this.a_processJunction_nns(continuation);
        return null;
    }
    
    protected NamingEnumeration<Binding> a_listBindings_nns(Continuation continuation) throws NamingException {
        this.a_processJunction_nns(continuation);
        return null;
    }
    
    protected void a_bind_nns(String s, Object o, Continuation continuation) throws NamingException {
        this.a_processJunction_nns(s, continuation);
    }
    
    protected void a_rebind_nns(String s, Object o, Continuation continuation) throws NamingException {
        this.a_processJunction_nns(s, continuation);
    }
    
    protected void a_unbind_nns(String s, Continuation continuation) throws NamingException {
        this.a_processJunction_nns(s, continuation);
    }
    
    protected Context a_createSubcontext_nns(String s, Continuation continuation) throws NamingException {
        this.a_processJunction_nns(s, continuation);
        return null;
    }
    
    protected void a_destroySubcontext_nns(String s, Continuation continuation) throws NamingException {
        this.a_processJunction_nns(s, continuation);
    }
    
    protected void a_rename_nns(String s, Name name, Continuation continuation) throws NamingException {
        this.a_processJunction_nns(s, continuation);
    }
    
    protected NameParser a_getNameParser_nns(Continuation continuation) throws NamingException {
        this.a_processJunction_nns(continuation);
        return null;
    }
    
    protected boolean isEmpty(String s) {
        return s == null || s.equals("");
    }
    
    @Override
    protected Object c_lookup(Name name, Continuation continuation) throws NamingException {
        Object a_lookup = null;
        if (this.resolve_to_penultimate_context(name, continuation)) {
            a_lookup = this.a_lookup(name.toString(), continuation);
            if (a_lookup != null && a_lookup instanceof LinkRef) {
                continuation.setContinue(a_lookup, name, this);
                a_lookup = null;
            }
        }
        return a_lookup;
    }
    
    @Override
    protected Object c_lookupLink(Name name, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context(name, continuation)) {
            return this.a_lookupLink(name.toString(), continuation);
        }
        return null;
    }
    
    @Override
    protected NamingEnumeration<NameClassPair> c_list(Name name, Continuation continuation) throws NamingException {
        if (this.resolve_to_context(name, continuation)) {
            return this.a_list(continuation);
        }
        return null;
    }
    
    @Override
    protected NamingEnumeration<Binding> c_listBindings(Name name, Continuation continuation) throws NamingException {
        if (this.resolve_to_context(name, continuation)) {
            return this.a_listBindings(continuation);
        }
        return null;
    }
    
    @Override
    protected void c_bind(Name name, Object o, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context(name, continuation)) {
            this.a_bind(name.toString(), o, continuation);
        }
    }
    
    @Override
    protected void c_rebind(Name name, Object o, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context(name, continuation)) {
            this.a_rebind(name.toString(), o, continuation);
        }
    }
    
    @Override
    protected void c_unbind(Name name, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context(name, continuation)) {
            this.a_unbind(name.toString(), continuation);
        }
    }
    
    @Override
    protected void c_destroySubcontext(Name name, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context(name, continuation)) {
            this.a_destroySubcontext(name.toString(), continuation);
        }
    }
    
    @Override
    protected Context c_createSubcontext(Name name, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context(name, continuation)) {
            return this.a_createSubcontext(name.toString(), continuation);
        }
        return null;
    }
    
    @Override
    protected void c_rename(Name name, Name name2, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context(name, continuation)) {
            this.a_rename(name.toString(), name2, continuation);
        }
    }
    
    @Override
    protected NameParser c_getNameParser(Name name, Continuation continuation) throws NamingException {
        if (this.resolve_to_context(name, continuation)) {
            return this.a_getNameParser(continuation);
        }
        return null;
    }
    
    @Override
    protected Object c_resolveIntermediate_nns(Name name, Continuation continuation) throws NamingException {
        if (this._contextType == 3) {
            Object a_resolveIntermediate_nns = null;
            if (this.resolve_to_penultimate_context_nns(name, continuation)) {
                a_resolveIntermediate_nns = this.a_resolveIntermediate_nns(name.toString(), continuation);
                if (a_resolveIntermediate_nns != null && a_resolveIntermediate_nns instanceof LinkRef) {
                    continuation.setContinue(a_resolveIntermediate_nns, name, this);
                    a_resolveIntermediate_nns = null;
                }
            }
            return a_resolveIntermediate_nns;
        }
        else {
            return super.c_resolveIntermediate_nns(name, continuation);
        }
    }
    
    @Override
    protected Object c_lookup_nns(Name name, Continuation continuation) throws NamingException {
        if (this._contextType == 3) {
            Object a_lookup_nns = null;
            if (this.resolve_to_penultimate_context_nns(name, continuation)) {
                a_lookup_nns = this.a_lookup_nns(name.toString(), continuation);
                if (a_lookup_nns != null && a_lookup_nns instanceof LinkRef) {
                    continuation.setContinue(a_lookup_nns, name, this);
                    a_lookup_nns = null;
                }
            }
            return a_lookup_nns;
        }
        else {
            return super.c_lookup_nns(name, continuation);
        }
    }
    
    @Override
    protected Object c_lookupLink_nns(Name name, Continuation continuation) throws NamingException {
        if (this._contextType == 3) {
            this.resolve_to_nns_and_continue(name, continuation);
            return null;
        }
        return super.c_lookupLink_nns(name, continuation);
    }
    
    @Override
    protected NamingEnumeration<NameClassPair> c_list_nns(Name name, Continuation continuation) throws NamingException {
        if (this._contextType == 3) {
            this.resolve_to_nns_and_continue(name, continuation);
            return null;
        }
        return super.c_list_nns(name, continuation);
    }
    
    @Override
    protected NamingEnumeration<Binding> c_listBindings_nns(Name name, Continuation continuation) throws NamingException {
        if (this._contextType == 3) {
            this.resolve_to_nns_and_continue(name, continuation);
            return null;
        }
        return super.c_listBindings_nns(name, continuation);
    }
    
    @Override
    protected void c_bind_nns(Name name, Object o, Continuation continuation) throws NamingException {
        if (this._contextType == 3) {
            if (this.resolve_to_penultimate_context_nns(name, continuation)) {
                this.a_bind_nns(name.toString(), o, continuation);
            }
        }
        else {
            super.c_bind_nns(name, o, continuation);
        }
    }
    
    @Override
    protected void c_rebind_nns(Name name, Object o, Continuation continuation) throws NamingException {
        if (this._contextType == 3) {
            if (this.resolve_to_penultimate_context_nns(name, continuation)) {
                this.a_rebind_nns(name.toString(), o, continuation);
            }
        }
        else {
            super.c_rebind_nns(name, o, continuation);
        }
    }
    
    @Override
    protected void c_unbind_nns(Name name, Continuation continuation) throws NamingException {
        if (this._contextType == 3) {
            if (this.resolve_to_penultimate_context_nns(name, continuation)) {
                this.a_unbind_nns(name.toString(), continuation);
            }
        }
        else {
            super.c_unbind_nns(name, continuation);
        }
    }
    
    @Override
    protected Context c_createSubcontext_nns(Name name, Continuation continuation) throws NamingException {
        if (this._contextType == 3) {
            if (this.resolve_to_penultimate_context_nns(name, continuation)) {
                return this.a_createSubcontext_nns(name.toString(), continuation);
            }
            return null;
        }
        else {
            return super.c_createSubcontext_nns(name, continuation);
        }
    }
    
    @Override
    protected void c_destroySubcontext_nns(Name name, Continuation continuation) throws NamingException {
        if (this._contextType == 3) {
            if (this.resolve_to_penultimate_context_nns(name, continuation)) {
                this.a_destroySubcontext_nns(name.toString(), continuation);
            }
        }
        else {
            super.c_destroySubcontext_nns(name, continuation);
        }
    }
    
    @Override
    protected void c_rename_nns(Name name, Name name2, Continuation continuation) throws NamingException {
        if (this._contextType == 3) {
            if (this.resolve_to_penultimate_context_nns(name, continuation)) {
                this.a_rename_nns(name.toString(), name2, continuation);
            }
        }
        else {
            super.c_rename_nns(name, name2, continuation);
        }
    }
    
    @Override
    protected NameParser c_getNameParser_nns(Name name, Continuation continuation) throws NamingException {
        if (this._contextType == 3) {
            this.resolve_to_nns_and_continue(name, continuation);
            return null;
        }
        return super.c_getNameParser_nns(name, continuation);
    }
    
    protected void a_processJunction_nns(String s, Continuation continuation) throws NamingException {
        if (s.equals("")) {
            NameNotFoundException ex2 = new NameNotFoundException();
            continuation.setErrorNNS(this, s);
            throw continuation.fillInException(ex2);
        }
        try {
            Object a_lookup = this.a_lookup(s, continuation);
            if (continuation.isContinue()) {
                continuation.appendRemainingComponent("");
            }
            else {
                continuation.setContinueNNS(a_lookup, s, this);
            }
        }
        catch (NamingException ex) {
            ex.appendRemainingComponent("");
            throw ex;
        }
        return;
    }
    
    protected void a_processJunction_nns(Continuation continuation) throws NamingException {
        continuation.setContinue(new Reference("java.lang.Object", new RefAddr("nns") {
            private static final long serialVersionUID = 3449785852664978312L;
            
            @Override
            public Object getContent() {
                return AtomicContext.this;
            }
        }), AtomicContext._NNS_NAME, this);
    }
    
    protected boolean resolve_to_context(Name name, Continuation continuation) throws NamingException {
        String string = name.toString();
        StringHeadTail c_parseComponent = this.c_parseComponent(string, continuation);
        String tail = c_parseComponent.getTail();
        String head = c_parseComponent.getHead();
        if (AtomicContext.debug > 0) {
            System.out.println("RESOLVE TO CONTEXT(" + string + ") = {" + head + ", " + tail + "}");
        }
        if (head == null) {
            throw continuation.fillInException(new InvalidNameException());
        }
        if (!this.isEmpty(head)) {
            try {
                Object a_lookup = this.a_lookup(head, continuation);
                if (a_lookup != null) {
                    continuation.setContinue(a_lookup, head, this, (tail == null) ? "" : tail);
                }
                else if (continuation.isContinue()) {
                    continuation.appendRemainingComponent(tail);
                }
            }
            catch (NamingException ex) {
                ex.appendRemainingComponent(tail);
                throw ex;
            }
            return false;
        }
        continuation.setSuccess();
        return true;
    }
    
    protected boolean resolve_to_penultimate_context(Name name, Continuation continuation) throws NamingException {
        String string = name.toString();
        if (AtomicContext.debug > 0) {
            System.out.println("RESOLVE TO PENULTIMATE" + string);
        }
        StringHeadTail c_parseComponent = this.c_parseComponent(string, continuation);
        String tail = c_parseComponent.getTail();
        String head = c_parseComponent.getHead();
        if (head == null) {
            throw continuation.fillInException(new InvalidNameException());
        }
        if (!this.isEmpty(tail)) {
            try {
                Object a_lookup = this.a_lookup(head, continuation);
                if (a_lookup != null) {
                    continuation.setContinue(a_lookup, head, this, tail);
                }
                else if (continuation.isContinue()) {
                    continuation.appendRemainingComponent(tail);
                }
            }
            catch (NamingException ex) {
                ex.appendRemainingComponent(tail);
                throw ex;
            }
            return false;
        }
        continuation.setSuccess();
        return true;
    }
    
    protected boolean resolve_to_penultimate_context_nns(Name name, Continuation continuation) throws NamingException {
        try {
            if (AtomicContext.debug > 0) {
                System.out.println("RESOLVE TO PENULTIMATE NNS" + name.toString());
            }
            int resolve_to_penultimate_context = this.resolve_to_penultimate_context(name, continuation);
            if (continuation.isContinue()) {
                continuation.appendRemainingComponent("");
            }
            return resolve_to_penultimate_context;
        }
        catch (NamingException ex) {
            ex.appendRemainingComponent("");
            throw ex;
        }
    }
    
    protected void resolve_to_nns_and_continue(Name name, Continuation continuation) throws NamingException {
        if (AtomicContext.debug > 0) {
            System.out.println("RESOLVE TO NNS AND CONTINUE" + name.toString());
        }
        if (this.resolve_to_penultimate_context_nns(name, continuation)) {
            Object a_lookup_nns = this.a_lookup_nns(name.toString(), continuation);
            if (a_lookup_nns != null) {
                continuation.setContinue(a_lookup_nns, name, this);
            }
        }
    }
    
    static {
        AtomicContext.debug = 0;
    }
}
